%	gramProp.pl v.2.02
%
%	version Chart
%		timeout = 0.1 (2 endroits : traiter, parse)
%		svinf <-- sn
%
%	What's new : 
%		suppression de virgule avant le connecteur
%		rajout de règle subC extra-préd finale
%

:- op(1200, xfx, --->).
:- dynamic known_phrase/3.
:- dynamic complete/2.
:- dynamic (--->)/2.


% ----- Procédure principale

analyser(NdeF1, NdeF2) :-
	open(NdeF1, read, _, [alias(input)]),
	open(NdeF2, write, _, [alias(output)]),
	%assert(deja_trouve(dumy)),
	%assert(known_phrase(dummy, 1000, 1000)),
	%assert(complete(dummy, 1000)),
	retractall(compteur(Z)),
	assert(compteur(0)),
	repeat,
	read(input, Exp),
	incremt(X),
	write(X),
	write(output, X),
	traiter(input, Exp),
	close(input),
	close(output).

incremt(X) :-
	!, compteur(Y),
	X is Y + 1,
	retract(compteur(Y)),
	assert(compteur(X)).

	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analyseur : Interface
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
traiter(input, _) :-					% fin du fichier input
	at_end_of_stream(input), !.

%traiter(_, Exp) :-
%	nb_vfin(Nb, Exp),	% nb_vfin(-Resultat, +Phrase)
%	Nb =< 1, !,
%	write([s, [prop, Exp]]), nl,
%	write(output, [s, [prop, Exp]]), nl(output),
%	fail.

traiter(_, Exp) :-
	retractall(connects(_, _, _)),
	retractall(known_phrase(_, _, _)),
	retractall(complete(_, _)),
	retractall(indMax(_)),
	retractall(debut(_)),
	entrer(Exp, 0, Nb),
	assert(indMax(Nb)),
	get_time(D),
	assert(debut(D)),
	parse(s(Res), 0, Nb), !, %( parse(s(Res), 0, Nb) ; Res = [s, [echec, Exp]] ),!,
	write(Res), nl,
	write(output, Res),
	get_time(T),
	debut(D),
	X is T - D,
	write(output, ' % temps = '), write(output, X), nl(output),!,
	fail.

traiter(_, Exp) :-
	get_time(T),
	debut(D),
	X is T - D,
	X > 10, !,
	Res = [s, [echec, Exp]],
	write(Res), nl,
	write(output, Res),
	write(output, ' % TIME OVER !!! temps = '), write(output, X), nl(output),!,
	fail.

traiter(_, _) :-
	retractall(known_phrase(_, _, _)),
	retractall(complete(_, _)),
	retractall(debut(_)),
	indMax(Nb),
	get_time(D),
	assert(debut(D)),
	assert('--->'(sn([propSN, qui(N), Sub]), ([qui(N)], (propss(Sub))))),
	assert('--->'(propcrd([propcrd, Prop]), (prop(Prop)))),
	assert('--->'(subC([subP, ou(X), Prop]), ([ou(X)], prop(Prop)))),
	assert('--->'(subC([subP, ou(X), Prop, Sub0]), ([ou(X)], prop(Prop), subCcrd(Sub0)))),
	parse(s(Res), 0, Nb), !, %( parse(s(Res), 0, Nb) ; Res = [s, [echec, Exp]] ),!,
	write(Res), nl,
	write(output, Res),
	get_time(T),
	debut(D),
	X is T - D,
	write(output, ' % temps = '), write(output, X), nl(output),!,
	retract('--->'(sn([propSN, qui(N), Sub]), ([qui(N)], (propss(Sub))))),
	retract('--->'(propcrd([propcrd, Prop]), (prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop]), ([ou(X)], prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop, Sub0]), ([ou(X)], prop(Prop), subCcrd(Sub0)))),
	fail.


traiter(_, _) :-
	retractall(known_phrase(_, _, _)),
	retractall(complete(_, _)),
	retractall(debut(_)),
	indMax(Nb),
	get_time(D),
	assert(debut(D)),
	assert('--->'(subC([subP, advp(A), que(N), Sub]), ([advp(A)], [que(N)], (prop(Sub))))),
	assert('--->'(sn([sn, np(N), SN]), ([np(N)], (sn(SN))))),
	parse(s(Res), 0, Nb), !,
	write(Res), nl,
	write(output, Res),
	get_time(T),
	debut(D),
	X is T - D,
	write(output, ' % temps = '), write(output, X), nl(output),!,
	retract('--->'(sn([propSN, qui(N), Sub]), ([qui(N)], (propss(Sub))))),
	retract('--->'(propcrd([propcrd, Prop]), (prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop]), ([ou(X)], prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop, Sub0]), ([ou(X)], prop(Prop), subCcrd(Sub0)))),
	retract('--->'(sn([sn, np(N), SN]), ([np(N)], (sn(SN))))),
	retract('--->'(subC([subP, advp(A), que(N), Sub]), ([advp(A)], [que(N)], (prop(Sub))))),
	fail.

traiter(_, Exp) :-
	retract('--->'(sn([propSN, qui(N), Sub]), ([qui(N)], (propss(Sub))))),
	retract('--->'(propcrd([propcrd, Prop]), (prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop]), ([ou(X)], prop(Prop)))),
	retract('--->'(subC([subP, ou(X), Prop, Sub0]), ([ou(X)], prop(Prop), subCcrd(Sub0)))),
	retract('--->'(sn([sn, np(N), SN]), ([np(N)], (sn(SN))))),
	retract('--->'(subC([subP, advp(A), que(N), Sub]), ([advp(A)], [que(N)], (prop(Sub))))),
	nb_vfin(Nb, Exp),	% nb_vfin(-Resultat, +Phrase)
	Nb =< 0, !,
	write([s, [prop, Exp]]), nl,
	write(output, [s, [prop, Exp]]), nl(output),
	fail.

traiter(_, Exp) :-
	write([s, [echec, Exp]]), nl,
	write(output, [s, [echec, Exp]]), nl(output),
	fail.

% predicats comptant le nombre de vfin
nb_vfin(0, []).
nb_vfin(Nb, [vfin(_)|Queue]) :-
	!,
	nb_vfin(Nb2, Queue),
	Nb is Nb2 + 1.
nb_vfin(Nb, [_|Queue]) :-
	nb_vfin(Nb, Queue).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Traitement des donnees entrees
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

entrer([], Nb, Nb).

entrer([X|Q], Ind, Nb) :-
	Y is Ind + 1,
	assert(connects(X, Ind, Y)),
	entrer(Q, Y, Nb).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Moteur de l'analyse tabulaire
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

parse(_, _, _) :-
	get_time(T),
	debut(D),
	X is T - D,
	X > 10, !,
	!, fail.

parse(NT, P0, P) :-
	nonterminal(NT),
	find_phrase(NT, P0, P).

parse((here(P0), Body2), P0, P) :-
	!, parse(Body2, P0, P).

parse((Body1, Body2), P0, P) :-
	parse(Body1, P0, P1),
	parse(Body2, P1, P).

parse((Body1; Body2), P0, P) :-
	( parse(Body1, P0, P) ; parse(Body2, P0, P) ).

parse([], P, P).
parse([Word|Rest], P0, P) :-
	connects(Word, P0, P1), !,
	parse(Rest, P1, P).

parse({Goals}, P, P) :-
	call(Goals).

find_phrase(NT, P0, P) :-
	complete(NT, P0), !,
	known_phrase(NT, P0, P).

find_phrase(NT, P0, P) :-
	(NT ---> Body),
	parse(Body, P0, P1),
	assert(known_phrase(NT, P0, P1)),
	P1 = P.

find_phrase(NT, P0, _) :-
	assert(complete(NT, P0)), !,
	fail.


nonterminal(L) :-
	\+ \+ (L ---> _BODY).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Grammaire pour la Détection des propositions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%		Phrases
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

s([s, open_g(X), Prop]) ---> [open_g(X)], s(Prop).

s([s, Sep, Prop]) ---> sep2(Sep), s(Prop).


% === Interrogation
% 11/29
s([s, [prop, Sep, Prop]]) ---> (sip(Sep) ; scamb(Sep) ; sque(Sep)), prop(Prop).

% === Coordination

s([s, Prop1]) ---> prop(Prop1).
s([s, Prop1, Crd]) ---> prop(Prop1), propcrd(Crd).

s([s, [cd, Cmp, vrg(X)], Prop1]) ---> cmp(Cmp), [vrg(X)], prop(Prop1).
s([s, [cd, Cmp, vrg(X)], Prop1, Crd]) ---> cmp(Cmp), [vrg(X)], prop(Prop1), propcrd(Crd).



s([s, Prop]) ---> sub(Prop).

s([s, Prop]) ---> sn(Prop).
s([s, Prop]) ---> cmp(Prop).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%		Propositions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
prop(_) ---> here(D),
	{ indMax(F),
	\+ appartient(vfin(_), D, F), !,
	fail}.

prop([prop, open_g(X), Prop]) ---> [open_g(X)], prop(Prop).

prop([prop, Prop]) ---> prop0(Prop).

% === une proposition en tete
prop([prop, [subT, Sub, vrg(X)], Prop]) ---> ( subC(Sub) ; cmp(Sub) ), [vrg(X)], prop(Prop).

prop([prop, Sub, Prop]) ---> ( subC(Sub) ; cmp(Sub) ), prop(Prop).



% === 07/28 regle pour le sujet detache : s ---> sn, vrg, sv
%     07/10 deplacement vers derriere la regle : prop(Prop) ---> prop0(Prop).
prop([prop, SN, vrg(X), SV]) ---> sujet(SN), [vrg(X)], pred(SV).

% === un syntagme en tete sans detachement
prop([prop, SN, Prop]) ---> sn(SN), prop0(Prop).

prop([prop, Cmp, Prop]) ---> cmp(Cmp), (prop0(Prop) ; propss(Prop)).

prop([prop, Prop]) ---> propss(Prop). % proposition sans sujet

% === un SN detache en tete ("cmp" détaché est traité par "sub0")
prop([prop, [subT, SN, vrg(X)], Prop]) ---> sn(SN), [vrg(X)], prop0(Prop).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%	Proposition basique
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
prop0([prop, clsj(X), Pred]) ---> [clsj(X)], pred(Pred).
prop0([prop, SN, Pred]) ---> sujet(SN), pred(Pred).

prop0([prop, clsj(X), Pred, vrg(Z), Sub]) ---> [clsj(X)], pred(Pred), [vrg(Z)], subC(Sub).
prop0([prop, SN, Pred, vrg(Z), Sub]) ---> sujet(SN), pred(Pred), [vrg(Z)], subC(Sub).

sujet([sujet, Suj]) ---> sn(Suj).
%sujet([sujet, Suj]) ---> svinf(Suj).
%%% sujet([sujet, qui(X), Sub]) ---> [qui(X)], propss(Sub). % provoque trop de bruit
%%% sujet([sujet, que(X), Sub]) ---> [que(X)], prop(Sub). % provoque trop de bruit


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	Proposition sans SN en tête
% pour l'inperatif et avec l'inversion du sujet, ainsi que pour les relatives en "qui" et avec l'inversion du sujet
%	- propss([prop, SV, Cmp]) ---> sv(SV), ?(subQ(Cmp); cmp(Cmp) ; sn(Cmp)).
% 	- propss([prop, SV]) ---> sv(SV), cmp(Cmp), sn(SN).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
propss([prop, SV, Cmp]) ---> sv(SV), (subQ(Cmp);cmp(Cmp);sn(Cmp)).
propss([prop, SV, Cmp, SN]) ---> sv(SV), cmp(Cmp), sn(SN). % mis en derriere 06/02/10 % mis en avant 06/02/17
propss([prop, SV]) ---> sv(SV).

propss([prop, SV, Cmp, vrg(X), Sub]) ---> sv(SV), (subQ(Cmp);cmp(Cmp);sn(Cmp)), [vrg(X)], subC(Sub).
propss([prop, SV, Cmp, SN, vrg(X), Sub]) ---> sv(SV), cmp(Cmp), sn(SN), [vrg(X)], subC(Sub). % mis en derriere 06/02/10 % mis en avant 06/02/17
propss([prop, SV, vrg(X), Sub]) ---> sv(SV), [vrg(X)], subC(Sub).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%	Propositions coordonnees
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
propcrd([propcrd, Sep, Prop1]) ---> sep2(Sep), prop(Prop1).
propcrd([propcrd, Sep, Prop1, Crd]) ---> sep2(Sep), prop(Prop1), propcrd(Crd).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%		Incidente (proposition simple)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
propinc([propinc, SV, Cmp]) ---> v(SV), (cmp(Cmp);sn(Cmp)).
propinc([propinc, SV]) ---> v(SV).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	Subordonees
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% === sub : pour la phrase autonome et pour l'incidente
sub([sub, Sep, Prop]) ---> squi(Sep), propss(Prop).
sub([sub, Sep, Prop, Sub]) ---> squi(Sep), propss(Prop), subrelcrd(Sub).

sub([sub, Sep, Prop]) --->	% rel = que, dont, rel, camb ; scs = cs ; sip = interrogatifs
	(srel(Sep) ; scs(Sep)), % ; sip(Sep, L, L1)),
	prop(Prop).
sub([sub, Sep, Prop, Sub]) --->	% rel = que, dont, rel, camb ; scs = cs ; sip = interrogatifs
	(srel(Sep) ; scs(Sep)), % ; sip(Sep, L, L1)),
	prop(Prop),
	sub0crd(Sub).

sub([sub, vrg(X), cc(Y), Prop]) ---> [vrg(X)], [cc(Y)], sub(Prop).

sub([sub, tiret(X), Prop]) --->   % ne permettant l'utilisation d'un tiret isole qu'a la fin de phrase
		 [tiret(X)],
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		( prop(Prop) ; sub(Prop) ).

sub([sub, tiret(X), cc(Y), Prop]) --->
		[tiret(X)], [cc(Y)], 
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		( prop(Prop) ; sub(Prop) ).

sub0crd([subcrd, Sep, Prop]) ---> sep2(Sep), sub(Prop).

% === subordonnees incidentes

%subinc([subinc, VRG1, Prop, VRG2]) ---> vrg(VRG1), {!}, (propinc(Prop)), vrg(VRG2). % prop normale ?
%subinc([subinc, open_p(X), Prop, close_p(Y)]) ---> [open_p(X)], {!}, prop(Prop), [close_p(Y)].
%subinc([subinc, tiret(X), Prop, tiret(Y)]) ---> [tiret(X)], {!}, prop(Prop), [tiret(Y)].

subdt([subinc, VRG1, Prop, VRG2]) ---> vrg(VRG1), (subC(Prop);propinc(Prop)), vrg(VRG2).
subdt([subinc, open_p(X), Prop, close_p(Y)]) ---> [open_p(X)], {!}, (subC(Prop);prop(Prop)), [close_p(Y)].
subdt([subinc, tiret(X), Prop, tiret(Y)]) ---> [tiret(X)], {!}, (subC(Prop);prop(Prop)), [tiret(Y)].

%subdtC([subinc, VRG1, Prop, VRG2]) ---> vrg(VRG1), (subC(Prop)), vrg(VRG2).
%subdtC([subinc, open_p(X), Prop, close_p(Y)]) ---> [open_p(X)], {!}, (subC(Prop)), [close_p(Y)].
%subdtC([subinc, tiret(X), Prop, tiret(Y)]) ---> [tiret(X)], {!}, (subC(Prop)), [tiret(Y)].

% === intégrative et circonstancielle : libre
subC([subP, Sep, Prop]) --->
	(sep1(Sep) ; sque(Sep)),
	prop(Prop).
subC([subP, Sep, Prop, Sub0]) --->
	(sep1(Sep) ; sque(Sep)),
	prop(Prop),
	subCcrd(Sub0).

subC([subP, tiret(X), Prop]) --->   % ne permettant l'utilisation d'un tiret isole qu'a la fin de phrase
		 [tiret(X)],
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subC(Prop).

subC([subP, tiret(X), cc(Y), Prop]) --->
		[tiret(X)], [cc(Y)], 
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subC(Prop).

subCcrd([subPcrd, Sep, Prop]) ---> sep2(Sep), subC(Prop). % reprise par "que" : si... et que ...


% === complétive et percontative : post-verbale
subQ([subQ, Sep, Prop]) --->
	(sque(Sep) ; sip(Sep) ; scamb(Sep)),
	prop(Prop).
subQ([subQ, Sep, Prop]) --->
	squi(Sep),
	propss(Prop).
subQ([subQ, Sep, Prop, Sub]) --->
	(sque(Sep) ; sip(Sep) ; scamb(Sep)),
	prop(Prop),
	subqcrd(Sub).
subQ([subQ, Sep, Prop, Sub]) --->
	squi(Sep),
	propss(Prop),
	subqcrd(Sub).

subQ([subQ, tiret(X), Prop]) --->   % ne permettant l'utilisation d'un tiret isole qu'a la fin de phrase
		 [tiret(X)],
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subQ(Prop).

subQ([subQ, tiret(X), cc(Y), Prop]) --->
		[tiret(X)], [cc(Y)], 
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subQ(Prop).


subqcrd([subQcrd, Sep, Prop]) ---> sep2(Sep), subQ(Prop).

% === relative
subreldt([subrel, VRG1, Sep, Prop, VRG2]) ---> vrg(VRG1),
	(	(squi(Sep), propss(Prop))
	;	(srel(Sep), prop(Prop))
	%;	(scamb(Sep), prop(Prop))
	),
	vrg(VRG2).
subreldt([subrel, open_p(X), Sep, Prop, close_p(Y)]) ---> [open_p(X)], {!},
	(	(squi(Sep), propss(Prop))
	;	(srel(Sep), prop(Prop))
	%;	(scamb(Sep), prop(Prop))
	),
	[close_p(Y)].
subreldt([subrel, tiret(X), Sep, Prop, tiret(Y)]) ---> [tiret(X)],
	(	(squi(Sep), propss(Prop))
	;	(srel(Sep), prop(Prop))
	%;	(scamb(Sep), prop(Prop))
	),
	[tiret(Y)].

subrel([subrel, vrg(X), Prop]) ---> [vrg(X)], subrel0(Prop).

subrel([subrel, tiret(X), Prop]) --->   % ne permettant l'utilisation d'un tiret isole qu'a la fin de phrase
		 [tiret(X)],
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subrel0(Prop).

subrel([subrel, tiret(X), cc(Y), Prop]) --->
		[tiret(X)], [cc(Y)], 
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		subrel0(Prop).

subrel(Prop) ---> subrel0(Prop).

subrel0([subrel, Sep, Prop]) --->
	(	(squi(Sep), propss(Prop))
	;	(srel(Sep), prop(Prop))
	%;	(scamb(Sep), prop(Prop))
	).
subrel0([subrel, Sep, Prop, Sub]) --->
	(	(squi(Sep), propss(Prop))
	;	(srel(Sep), prop(Prop))
	%;	(scamb(Sep), prop(Prop))
	),
	subrelcrd(Sub).


subrelcrd([subRcrd, ET, Prop]) ---> sep2(ET), subrel(Prop).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	Separateurs et virgule
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sep([sep, camb(X)]) ---> [camb(X)].
sep([sep, ip(X)]) ---> [ip(X)].
sep([sep, cs(X)]) ---> [cs(X)].
sep([sep, cc(X)]) ---> [cc(X)].
sep([sep, qui(X)]) ---> [rel(X)].
sep([sep, vrg(X)]) ---> [vrg(X)].
sep([sep, qui(X)]) ---> [qui(X)].
sep([sep, que(X)]) ---> [que(X)].
sep([sep, dont(X)]) ---> [dont(X)].
sep([sep, ou(X)]) ---> [ou(X)].


sep1(X) ---> scamb(X).
sep1(X) ---> scs(X).

% ip : pourquoi, comment, combien, combien de N, quel(les) N
%sip([sep, vrg(X), Sep]) ---> [vrg(X)], sip(Sep).
sip([sep, open_g(X), Sep]) ---> [open_g(X)], sip(Sep).
sip([sep, p(P), ip(X), Cmp]) ---> [p(P)], [ip(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. "à quel ..., (incidente), ..."
sip([sep, p(P), qui(X), Cmp]) ---> [p(P)], [qui(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. à qui, de qui, pour qui
sip([sep, p(P), ou(X), Cmp]) ---> [p(P)], [ou(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. à qui, de qui, pour qui
sip([sep, ip(X), Cmp]) ---> [ip(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. "où, (incidente), ..."
sip([sep, ou(X), Cmp]) ---> [ou(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. "où, (incidente), ..."
sip([sep, p(P), ip(X)]) ---> [p(P)], [ip(X)]. 	% ex. "à quel ...
sip([sep, p(P), qui(X)]) ---> [p(P)], [qui(X)]. 	% ex. à qui, de qui, pour qui
sip([sep, p(P), ou(X)]) ---> [p(P)], [ou(X)]. 	% ex. à qui, de qui, pour qui
sip([sep, ip(X)]) ---> [ip(X)].
sip([sep, ou(X)]) ---> [ou(X)].

% camb : quand, comme, si
%scamb([sep, vrg(X), Sep]) ---> [vrg(X)], scamb(Sep).
scamb([sep, open_g(X), Sep]) ---> [open_g(X)], scamb(Sep).
scamb([sep, p(P), camb(X), Cmp]) ---> [p(P)], [camb(X)], (cmpinc(Cmp);subinc(Cmp)). 	% ex. "d'où"
scamb([sep, camb(X), Cmp]) ---> [camb(X)], (cmpinc(Cmp);subinc(Cmp)). 	% ex. "si, (incidente), ..."
scamb([sep, p(P), camb(X)]) ---> [p(P)], [camb(X)].
scamb([sep, camb(X)]) ---> [camb(X)].

% cs : lorsque, alors que, tandis que, pourvu que, d'autant que, parce que, puisque, pour que, bien que... etc.
%scs([sep, vrg(X), Sep]) ---> [vrg(X)], scs(Sep).
scs([sep, open_g(X), Sep]) ---> [open_g(X)], scs(Sep).
scs([sep, cs(X), Cmp]) ---> [cs(X)], (cmpinc(Cmp);subinc(Cmp)). 	% ex. "lorsque, (incidente), ..."
%scs([sep, p(X), cs(Y)]) ---> [p(X)], [cs(Y)].	% 
scs([sep, cs(X)]) ---> [cs(X)].

% rel : lequel, quoi, que, dont
%srel([sep, vrg(X), cc(Y), Sep]) ---> [vrg(X)], [cc(Y)], srel(Sep).
%srel([sep, vrg(X), Sep]) ---> [vrg(X)], srel(Sep).
srel([sep, open_g(X), Sep]) ---> [open_g(X)], srel(Sep).
srel([sep, X, Cmp]) ---> srel0(X), (cmpinc(Cmp);subdt(Cmp)). 	% ex. "lequel, (incidente), ..."
srel(X) ---> srel0(X).

srel0([sep, p(P), rel(X)]) ---> [p(P)], [rel(X)].				% ex. "dans lequel"
srel0([sep, p(P), qui(X)]) ---> [p(P)], [qui(X)].				% ex. "à qui"
srel0([sep, p(P), ou(X)]) ---> [p(P)], [ou(X)].				% ex. "à qui"
srel0([sep, rel(X)]) ---> [rel(X)].
srel0([sep, que(X)]) ---> [que(X)].
srel0([sep, dont(X)]) ---> [dont(X)].
srel0([sep, ou(X)]) ---> [ou(X)].

% qui : qui
%squi([sep, vrg(X), cc(Y), Sep]) ---> [vrg(X)], [cc(Y)], squi(Sep).
%squi([sep, vrg(X), Sep]) ---> [vrg(X)], squi(Sep).
squi([sep, open_g(X), Sep]) ---> [open_g(X)], squi(Sep).
squi([sep, qui(X), Cmp]) ---> [qui(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. "qui, (incidente), ..."
squi([sep, qui(X)]) ---> [qui(X)].

% que : que
%sque([sep, vrg(X), cc(Y), Sep]) ---> [vrg(X)], [cc(Y)], sque(Sep).
%sque([sep, vrg(X), Sep]) ---> [vrg(X)], sque(Sep).
sque([sep, open_g(X), Sep]) ---> [open_g(X)], sque(Sep).
sque([sep, que(X), Cmp]) ---> [que(X)], (cmpinc(Cmp);subdt(Cmp)). 	% ex. "que, (incidente), ..."
sque([sep, que(X)]) ---> [que(X)].

sep2([sep, vrg(X), Sep2]) ---> [vrg(X)], sep2(Sep2).
sep2([sep, cc(X), advp(Y)]) ---> [cc(X)], [advp(Y)].	% ex. "et finalement", ", notamment"
sep2([sep, vrg(X), advp(Y)]) ---> [vrg(X)], [advp(Y)], {!}.
sep2([sep, cc(X), Cmp]) ---> [cc(X)], (cmpinc(Cmp);subdt(Cmp)). %cmpinc(Cmp).
sep2([sep, cc(X)]) ---> [cc(X)].
sep2([sep, vrg(X)]) ---> [vrg(X)].

tiret([sep, tiret(X)]) ---> [tiret(X)].
vrg([sep, vrg(X)]) ---> [vrg(X)].

sepamb([sep, p(P), camb(X)]) ---> [p(P)], [camb(X)].
sepamb([sep, p(P), ip(X)]) ---> [p(P)], [ip(X)].
sepamb([sep, p(P), rel(X)]) ---> [p(P)], [rel(X)].
sepamb([sep, p(P), qui(X)]) ---> [p(P)], [qui(X)].
sepamb([sep, p(P), ou(X)]) ---> [p(P)], [ou(X)].
sepamb([sep, camb(X)]) ---> [camb(X)].
sepamb([sep, ip(X)]) ---> [ip(X)].
sepamb([sep, rel(X)]) ---> [rel(X)].
sepamb([sep, que(X)]) ---> [que(X)].
sepamb([sep, dont(X)]) ---> [dont(X)].
sepamb([sep, ou(X)]) ---> [ou(X)].


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%		Predicat
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pred([predicat, SV]) --->
	pred0(SV).
pred([predicat, SV, Sub]) --->
	pred0(SV), subC(Sub).
	


pred0([predicat, SV, Cmp]) --->
	sv(SV),
	( subQ(Cmp); sn(Cmp); cmp(Cmp)).
pred0([predicat, SV]) --->
	sv(SV).

pred0([predicat, SV, Cmp1, Cmp2]) --->
	sv(SV),
	cmp(Cmp1),
	(subQ(Cmp2);sn(Cmp2)).		% 7/12


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 		Verbe
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
v0([v, vfin(X), clsj(Y)]) ---> [vfin(X)], [clsj(Y)]. % 18/10/05
v0([v, vfin(X), trait(Z), clsj(Y)]) ---> [vfin(X)], [trait(Z)], {!}, [clsj(Y)].
v0([v, vfin(X), Sub]) ---> [vfin(X)], (cmpinc(Sub) ; subdt(Sub)).
v0([v, vfin(X)]) ---> [vfin(X)], {!}.

v([v, Cltq, SV]) ---> cltq(Cltq), v(SV).

v([v, X, advp(Y), vpt(Z)]) ---> v0(X), [advp(Y)], [vpt(Z)], {!}.
v([v, X, vpt(Y)]) ---> v0(X), [vpt(Y)], {!}.
v([v, X, advp(Y)]) ---> v0(X), [advp(Y)], {!}.
v(X) ---> v0(X).


sv([sv, open_g(X), SV]) ---> [open_g(X)], sv(SV).

sv([sv, SV]) ---> 	v(SV).
sv([sv, SV, Sub]) --->
	v(SV),
	(cmpinc(Sub); subdt(Sub)).

%%% Clitiques

cltq([cltq, ne(X), Cltq]) ---> [ne(X)], cltq0(Cltq). 
cltq(Cltq) ---> cltq0(Cltq).
cltq([cltq, ne(X)]) ---> [ne(X)], {!}. 

cltq0([cltq, clns(X), Cltq]) ---> [clns(X)], cltq0(Cltq). 
cltq0([cltq, clns(X)]) ---> [clns(X)], {!}. 


%%%%% Verbe infinitif
%%%%% se comportant comme SN : ex. Dormir avec son bebe est ... ---> pas de regle
%%%%% vinf + vinf = faire renier LMD 1495
vinf00([vinf, vinf(X)]) ---> [vinf(X)]. 
vinf00([vinf, vinf(X), Inc]) ---> [vinf(X)], (cmpinc(Inc) ; subdt(Inc)). 

vinf0([vinf, advp(X), SV]) --->  [advp(X)], vinf0(SV). 
vinf0([vinf, Cltq, SV]) --->  cltq(Cltq), vinf0(SV). 
vinf0(SV) ---> vinf00(SV).

svinf([svinf, open_g(X), Vinf]) ---> [open_g(X)], svinf(Vinf).

%svinf --->  vinf0, (cmp | sn | subq | svinf | crdsvinf), crdsvinf.

svinf([svinf, Vinf, Cmp]) --->
	vinf0(Vinf),
	(subQ(Cmp) ;cmp(Cmp) ;sn(Cmp) ;svinf(Cmp)).

svinf([svinf, Vinf, Cmp, SN]) --->
	vinf0(Vinf),
	cmp(Cmp),
	sn(SN).

svinf([svinf, Vinf]) --->
	vinf0(Vinf).



svinf([svinf, Vinf, Cmp, Crd]) --->
	vinf0(Vinf),
	(subQ(Cmp) ;cmp(Cmp) ;sn(Cmp) ;svinf(Cmp)),
	(crdsvinf(Crd) ;subC(Crd)).
svinf([svinf, Vinf, Cmp, SN, Crd]) --->
	vinf0(Vinf),
	cmp(Cmp),
	sn(SN),
	(crdsvinf(Crd);	subC(Crd)).
svinf([svinf, Vinf, Crd]) --->
	vinf0(Vinf),
	(crdsvinf(Crd);	subC(Crd)).

crdsvinf([crdsvinf, SEP, SVINF]) ---> sep2(SEP), svinf(SVINF).



%%%%% Verbe pt. pré.
%%%%% se comportant comme Cmp
vptpr00([vptpr, vptpr(X), Inc]) ---> [vptpr(X)], (cmpinc(Inc) ; subdt(Inc)). 
vptpr00([vptpr, vptpr(X)]) ---> [vptpr(X)]. 

vptpr0([vptpr, advp(X), SV]) --->  [advp(X)], vptpr0(SV). 
vptpr0([vptpr, Cltq, SV]) --->  cltq(Cltq), vptpr0(SV). 
vptpr0(SV) ---> vptpr00(SV). 

vgr([vgr, advp(X), p(Y), SV]) ---> [advp(X)], [p(Y)], {!}, vptpr0(SV).
vgr([vgr, p(X), SV]) ---> [p(X)], {!}, vptpr0(SV).
%vgr([vgr, advp(X), vptpr(Y)]) ---> [advp(X)], [vptpr(Y)], {!}.
vgr([vgr, SV]) ---> vptpr0(SV), {!}.

vgr([vgr, advp(X), vger(Y)]) ---> [advp(X)], [vger(Y)].
vgr([vgr, vger(X)]) ---> [vger(X)].

%vgr([vgr,  Cltq, SV]) ---> cltq(Cltq), vgr(SV).


%%%%% Verbe infinitif prépositionnel
%%%%% se comportant comme Cmp : ex. Je cherche un endroit pour partir ...
ppv([ppv, advp(X), p(Y), SV]) ---> [advp(X)], [p(Y)], {!}, vinf0(SV).
ppv([ppv, p(X), SV]) ---> [p(X)], {!}, vinf0(SV).
ppv([ppv, advp(X), ppvinf(Y)]) ---> [advp(X)], [ppvinf(Y)], {!}.
ppv([ppv, ppvinf(X)]) ---> [ppvinf(X)], {!}.

svprep([svprep, open_g(X), SVP]) ---> [open_g(X)], svprep(SVP).

% === svprep ---> (svprep0), (cmp), ?(crdsvprep).

svprep([svprep, X, Cmp]) --->
	svprep0(X),
	(subQ(Cmp);cmp(Cmp);sn(Cmp)).

% === svprep ---> (svprep0), cmp, sn, ?(crdsvprep).
svprep([svprep, X, Cmp, SN]) --->
	svprep0(X),
	cmp(Cmp),
	sn(SN).

% === svprep ---> (svprep0), ?(crdsvprep).
svprep([svprep, X]) --->
	svprep0(X).

svprep([svprep, X, Cmp, Crd]) --->
	svprep0(X),
	(subQ(Cmp);cmp(Cmp);sn(Cmp)),
	(crdsvinf(Crd);crdsvprep(Crd);subC(Crd)).
svprep([svprep, X, Cmp, SN, Crd]) --->
	svprep0(X),
	cmp(Cmp),
	sn(SN),
	(crdsvinf(Crd);crdsvprep(Crd);subC(Crd)).
svprep([svprep, X, Crd]) --->
	svprep0(X),
	(crdsvinf(Crd);crdsvprep(Crd);subC(Crd)).

%%% svprep0 ---> (ppv|vgr), ?(incident).
svprep0([svprep0, X]) --->	(ppv(X) ; vgr(X)).
svprep0([svprep0, X, Inc]) --->	(ppv(X) ; vgr(X)), (subdt(Inc);cmpinc(Inc)).

%%% crdsvprep
crdsvprep([crdsvinf, SEP, SVPREP]) ---> sep2(SEP), svprep(SVPREP).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	Syntagme nominal : Objet directe
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sn([sn, d(D), open_g(X), SN]) ---> [d(D)], [open_g(X)], sn(SN).
sn([sn, open_g(X), SN]) ---> [open_g(X)], sn(SN).

sn([sn, d(X), SN]) ---> [d(X)], sn(SN).
sn([sn, adj(X), SN]) ---> [adj(X)], sn(SN).


% sn ---> [np], ?(sub|cmpcrd|cmp).
sn([sn, N]) --->
		sn0(N).
sn([sn, N, Cmp]) --->
		sn0(N),
		( subrel(Cmp);subreldt(Cmp);cmp(Cmp);cmpcrd(Cmp)).

% sn ---> [np], cmp, (sub).
sn([sn, N, Cmp, Sub]) --->
		sn0(N),
		cmp(Cmp),
		(subrel(Sub);subreldt(Sub)).

%sn ---> [np], (subinc|cmpinc), ?(sub|cmpcrd|cmp).
sn([sn, N, Inc]) --->
		sn0(N),
		(subdt(Inc) ; cmpinc(Inc)).
sn([sn, N, Inc, Cmp]) --->
		sn0(N),
		(subdt(Inc) ; cmpinc(Inc)),
		( subrel(Cmp);subreldt(Cmp);cmpcrd(Cmp);cmp(Cmp)).




sn0(NP) ---> snprop(NP).
sn0([sn, np(X), NP]) ---> [np(X)], snprop(NP).
sn0([sn, np(X)]) ---> [np(X)].
sn0([sn, pro(X)]) ---> [pro(X)].
sn0([sn, np(X), trait(Y), np(Z)]) ---> [np(X)],[trait(Y)],[np(Z)].

snprop([sn, nprop(X)]) ---> [nprop(X)]. % plusieurs noms propores
snprop([sn, nprop(X), N]) ---> [nprop(X)], snprop(N). % plusieurs noms propores
snprop([sn, nprop(X), N]) ---> [trait(X)], snprop(N). % plusieurs noms propores
snprop([sn, nprop(X), N]) ---> [et(X)], snprop(N). % plusieurs noms propores
snprop([sn, open_g(X), N, close_g(Y)]) ---> [open_g(X)], sn(N), [close_g(Y)]. % plusieurs noms propores
sn([sn, SVINF]) ---> svinf(SVINF).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%		CMPINC : cmp incident
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% toute sequence entouree des virgules ou des parentheses sont incise quelle que soit sa structure
cmpinc([cmpinc, vrg(X), advp(X), Cmp, vrg(Y)]) ---> [vrg(X)], [advp(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [vrg(Y)].
cmpinc([cmpinc, vrg(X), Cmp, vrg(Y)]) ---> [vrg(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [vrg(Y)].

% apposition = la chapelle[np] saint-benoît[np]
cmpinc([cmpinc, vrg(X), np(Z1), np(Z2), vrg(Y)]) ---> [vrg(X)], [np(Z1)], [np(Z2)],  [vrg(Y)].

cmpinc([cmpinc, tiret(X), Cmp, tiret(Y)]) ---> [tiret(X)], [advp(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [tiret(Y)].
cmpinc([cmpinc, open_p(X), Cmp, close_p(Y)]) ---> [open_p(X)], [advp(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [close_p(Y)].
cmpinc([cmpinc, tiret(X), Cmp, tiret(Y)]) ---> [tiret(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [tiret(Y)].
cmpinc([cmpinc, open_p(X), Cmp, close_p(Y)]) ---> [open_p(X)], (sn(Cmp);cmp(Cmp);cmpcrd(Cmp)), [close_p(Y)].

cmpinc([cmpinc, open_p(X), [nonprop | Cmp], close_p(Y)]) ---> [open_p(X)], nonprop(Cmp), [close_p(Y)].
	
nonprop([]) ---> [].
nonprop([E | Q]) ---> [E], { \+ E = close_p(_)}, nonprop(Q).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%		CMPCRD : cmp coordonné - ceux qui ne peuvent pas être complément primaire du verbe ???
%						ex. *je rentre, à la maison
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% cmp détaché par un tiret
% 	on ne permet l'utilisation d'un tiret isole qu'a la fin de phrase
cmpcrd([cmpcrd, tiret(X), Cmp]) ---> [tiret(X)], 
		{ indMax(F), \+ appartient(tiret(_), X, F), ! },
		(cmp(Cmp);sn(Cmp);cmpcrd(Cmp)).


cmpcrd([cmpcrd, Sep, Cmp]) ---> sep2(Sep), (cmp(Cmp);sn(Cmp);cmpcrd(Cmp)).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%		CMP : Complements accessoire et secondaire
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%
cmp([cmp, open_g(X), Cmp]) ---> [open_g(X)], cmp(Cmp).

%%%%%%%%%%
% cmp ---> sepamb, 	= que, pourquoi, où, combien...  
%	( cmp ;		= plus ... que grand  (= svprep  = ne ... qu'à faire)
%	  sn ;		= plus ... que les livres, pourquoi cette question
%	  svinf ).	= ne ... que faire, pourquoi faire..., où aller

cmp([cmp, Sep, Cmp]) --->
	sepamb(Sep), here(D),
	{ indMax(F), 
	( \+ appartient(vfin(_), D, F) ; appartient(vrg(_), D, F) ; appartient(qui(_), D, F) ; appartient(que(_), D, F) ; appartient(dont(_), D, F) ; appartient(rel(_), D, F) ; appartient(cs(_), D, F) ; appartient(camb(_), D, F) ; appartient(ip(_), D, F) ; appartient(cc(_), D, F) )
	},
	( cmp(Cmp) ; sn(Cmp)).	% ne ... que faire

% cmp ---> p, (sn | svprep | cmp)
cmp([cmp, p(X), Cmp]) ---> [p(X)], 
	( sn(Cmp) ; cmp(Cmp)). % ; svprep(Cmp, L, Q)). 	% mise en tete des cmp commencant par p 09/15


% cmp ---> adj + que + prop = si fort que (soit Pierre), ... 
cmp([cmp, adj(X), [subQ, Sep, Prop]]) ---> [adj(X)], sque(Sep), prop(Prop).

% cmp ---> d, advp, cmp 		= le[d] plus[advp] (de femmes), (femme) la[d] plus[advp] consideree[adj] 
cmp([cmp, d(X), advp(Y), Cmp]) ---> [d(X)], [advp(Y)], cmp(Cmp). 


% cmp ---> d, advp 		= (il mange) le plus 
cmp([cmp, d(X), advp(Y)]) ---> [d(X)], [advp(Y)].

% cmp ---> ?(vrg), svprep
cmp([cmp, vrg(X), SV]) ---> [vrg(X)], svprep(SV).

cmp([cmp, SV]) ---> svprep(SV).


% cmp ---> cmp0, (subrel(Sub); subreldt(Sub); cmpcrd(Sub))?.
cmp([cmp, X]) ---> % mise en tête 06/03/07
	cmp0(X).

cmp([cmp, X, Cmp]) --->
	cmp0(X),
	cmpcrd(Cmp).


%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%	CMP0 = cmp "basique"
%%		permettant la structure recursive (récursivité à droite)
%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% cmp0 ---> vrg ?, ((atr) | (atr, cmp) | (atr, incident) | (atr, incident, cmp))

cmp0([cmp, vrg(X), E, Sub]) ---> [vrg(X)], [E], { atr(E) },
	( subdt(Sub) ; cmpinc(Sub)).
cmp0([cmp, vrg(X), E, Sub, Cmp]) ---> [vrg(X)], [E], { atr(E) },
	( subdt(Sub) ; cmpinc(Sub)),
	cmp(Cmp).

cmp0([cmp, vrg(X), E]) ---> [vrg(X)], [E], { atr(E) }.
cmp0([cmp, vrg(X), E, Cmp]) ---> [vrg(X)], [E], { atr(E) }, cmp(Cmp).


cmp0([cmp, E]) --->
	 [E], { atr(E) }.
cmp0([cmp, E, Cmp]) --->
	 [E], { atr(E) }, cmp(Cmp).

cmp0([cmp, E, Sub]) --->  [E], { atr(E) },
	( subdt(Sub) ; cmpinc(Sub)).
cmp0([cmp, E, Sub, Cmp]) --->  [E], { atr(E) },
	( subdt(Sub) ; cmpinc(Sub)), cmp(Cmp).


%% cmp0 ---> [vrg], [pp], (subinc | sundtC | cmpinc), (cmp | subR) ?.
cmp0([cmp, vrg(X), pp(PP), Sub]) ---> [vrg(X)], [pp(PP)], 
	( subdt(Sub) ; cmpinc(Sub) ).
cmp0([cmp, vrg(X), pp(PP), Sub, Cmp]) ---> [vrg(X)], [pp(PP)], 
	( subdt(Sub) ; cmpinc(Sub) ),
	( cmp(Cmp);subrel(Cmp);subreldt(Cmp) ).

%% cmp0 ---> [vrg], [pp], cmp, subR ?.
cmp0([cmp, vrg(X), pp(PP), Cmp]) ---> [vrg(X)], [pp(PP)], cmp(Cmp).
cmp0([cmp, vrg(X), pp(PP), Cmp, Sub]) ---> [vrg(X)], [pp(PP)], cmp(Cmp), (subrel(Sub);subreldt(Sub)).

%% cmp0 ---> [vrg], [pp], subR ?.
cmp0([cmp, vrg(X), pp(PP)]) ---> [vrg(X)], [pp(PP)].
cmp0([cmp, vrg(X), pp(PP), Sub]) ---> [vrg(X)], [pp(PP)], (subrel(Sub);subreldt(Sub)).


cmp0([cmp, pp(PP), Sub]) ---> [pp(PP)], ( subdt(Sub) ; cmpinc(Sub) ).
cmp0([cmp, pp(PP), Sub, Cmp]) ---> [pp(PP)], ( subdt(Sub) ; cmpinc(Sub) ),
					( cmp(Cmp);subrel(Cmp);subreldt(Cmp) ).

cmp0([cmp, pp(PP), Cmp]) ---> [pp(PP)], 
	( cmp(Cmp) ).
cmp0([cmp, pp(PP), Cmp, Sub]) ---> [pp(PP)], 
	( cmp(Cmp) ),
	( subrel(Sub);subreldt(Sub) ).

cmp0([cmp, pp(PP)]) ---> [pp(PP)].
cmp0([cmp, pp(PP), Sub]) ---> [pp(PP)], ( subrel(Sub);subreldt(Sub) ).



%%%%% elements divers

atr(X) :-
	%\+ [X] = [], !,	
	\+ X = vfin(_),
	\+ X = vinf(_),
	\+ X = vger(_),
	\+ X = vptpr(_),
	\+ X = np(_),
	\+ X = pro(_),
	\+ X = clns(_),
	\+ X = d(_),
	\+ X = p(_),
	\+ X = clsj(_),
	\+ X = ppvinf(_),
	\+ X = open_p(_),
	\+ X = close_p(_),
	\+ X = tiret(_),
	\+ X = ne(_),
	\+ X = pp(_),
	\+ X = camb(_),
	\+ X = ip(_),
	\+ X = cs(_),
	\+ X = cc(_),
	\+ X = rel(_),
	\+ X = vrg(_),
	\+ X = qui(_),
	\+ X = que(_),
	\+ X = ou(_),
	\+ X = dont(_).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Traitement des vides
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


appartient(_, Debut, Fin) :-
	Debut >= Fin, !,
	fail.
appartient(X, Debut, Fin) :-
	D2 is Debut + 1, !,
	(connects(X, Debut, D2) ; appartient(X, D2, Fin)).
